const String index_html = "\
<!DOCTYPE html> \n\
<html lang='ja'> \n\
<head> \n\
<meta charset='UTF-8'> \n\
<meta name='viewport' content='width=320'> \n\
<title>Car Controller（JoyPad)</title> \n\
<style type='text/css'><!-- \n\
.div_CT { width:310px; text-align:center; } \n\
.btn_LX { width:124px; height:36px; text-align:center; padding:8px; border-radius:7px; background-color:#888888; } \n\
--></style> \n\
</head> \n\
\
<body> \n\
<div id='poss' class='div_CT'>--</div> \n\
<canvas id='canvas' width=310 height=310></canvas> \n\
<div class='div_CT'> \n\
<input id='ex_R' type=button class='btn_LX' onclick='Btn(8)' value='クラクション'> \
<input id='ex_S' type=button class='btn_LX' onclick='Btn(9)' value='ライト'> \n\
</div> \n\
<div id='send' class='div_CT'></div> \n\
\
<script type='text/javascript'> \n\
var poss    = document.getElementById('poss'); \n\
var send    = document.getElementById('send'); \n\
var canvas  = document.getElementById('canvas'); \n\
var context = canvas.getContext('2d'); \n\
var sx = 9999, sy; \n\
var PI2 = (2 * Math.PI); \n\
var JPcr = (canvas.width / 2); \n\
var JPcx = JPcy = JPcr; \n\
var JPrr = 80; \n\
\
var FLv = 0, CLv = 0, Rv = 0, Lv = 0; \n\
var xhr = new XMLHttpRequest(), reqSend = 0, reqRet = 0, idleCnt = 0; \n\
xhr.onreadystatechange = HttpRes; \n\
\
function HttpRes() { \n\
  if (xhr.readyState == 4 && xhr.status == 200) reqRet = 0; \n\
} \n\
\
function HttpReq(v) { \n\
  xhr.open('GET', '/rc?' + v); \n\
  xhr.send(null); \n\
  reqRet = 1; \n\
} \n\
\
function Btn(n) { \n\
  if (n == 8) { \n\
    CLv = 60; \n\
  } else if (n == 9) { \n\
    FLv = ((FLv) ? 0 : 1); \n\
    document.getElementById('ex_S').style.backgroundColor = ((FLv) ? '#F0F8FF' : '#888888'); \n\
  } \n\
  reqSend++; \n\
} \n\
\
canvas.addEventListener('touchend', function(e) { \n\
  posg(0, 0); \n\
  Rv = Lv = 0; \n\
  reqSend = 3; \n\
}, false); \n\
\
canvas.addEventListener('touchmove', function(e) { \n\
  e.preventDefault(); \n\
  var xx = Math.floor(e.touches[0].pageX - canvas.offsetLeft); \n\
  var yy = Math.floor(e.touches[0].pageY - canvas.offsetTop); \n\
  context.beginPath(); \n\
  context.arc(JPcx, JPcy, JPrr, 0, PI2, true); \n\
  context.closePath(); \n\
  if (!context.isPointInPath(xx, yy)) { \n\
    var ratio = Math.sqrt(Math.pow(JPrr, 2) / (Math.pow(Math.abs(xx -= JPcx), 2) + Math.pow(Math.abs(yy -= JPcy), 2))); \n\
    xx = (Math.floor((xx * ratio) + JPcx)); \n\
    yy = (Math.floor((yy * ratio) + JPcy)); \n\
  } \n\
  posg((xx -= JPcx), (yy -= JPcy)); \n\
  var mpower = Math.round(Math.sqrt(Math.pow(Math.abs(xx), 2) + Math.pow(Math.abs(yy), 2))); \n\
  if ((yy > -16) && (yy < 16)) { \n\
    Rv = ((xx < 0) ?  mpower : -mpower); \n\
    Lv = ((xx > 0) ?  mpower : -mpower); \n\
  } else { \n\
    mpower = Math.floor((mpower < 16) ? 0 : ((yy > 0) ? (0 - mpower) : mpower)); \n\
    Rv = Math.floor((xx < 0) ? mpower : (mpower - (mpower * Math.abs(xx) / JPrr))); \n\
    Lv = Math.floor((xx > 0) ? mpower : (mpower - (mpower * Math.abs(xx) / JPrr))); \n\
  } \n\
  reqSend++; \n\
}, false); \n\
\
function posg(x, y) { \n\
  if (sx == 9999) { \n\
    context.strokeStyle = 'blue'; \n\
    context.fillStyle = '#CED8F6'; \n\
    context.lineWidth = 1; \n\
    context.beginPath(); \n\
    context.arc(JPcx, JPcy, (JPcr - 1), 0, PI2, true); \n\
    context.fill(); \n\
    context.stroke(); \n\
  } else { \n\
    context.fillStyle = '#CED8F6'; \n\
    context.beginPath(); \n\
    context.arc((sx + JPcx), (sy + JPcy), 72, 0, PI2, true); \n\
    context.fill(); \n\
  } \n\
  context.strokeStyle = 'red'; \n\
  context.fillStyle = 'pink'; \n\
  context.lineWidth = 2; \n\
  context.beginPath(); \n\
  context.arc((x + JPcx), (y + JPcy), 70, 0, PI2, true); \n\
  context.stroke(); \n\
  context.fill(); \n\
  poss.innerHTML = ((x == 0 && y == 0) ? '--' : ('X : ' + x + ', Y : ' + y)); \n\
  sy = y; \n\
  sx = x; \n\
} \n\
\
var timer = window.setInterval(function() { \n\
  var vals = 'F=' + FLv + '&C=' + CLv + '&L=' + Lv + '&R=' + Rv; \n\
  send.innerHTML = vals; \n\
  if (reqSend) { \n\
    CLv = 0; \n\
    reqSend--; \n\
    idleCnt = 0; \n\
  } \n\
  if (++idleCnt < ((20 * 1000) / 50)) { \n\
    HttpReq(vals); \n\
  } \n\
}, 50); \n\
\
posg(0, 0); \n\
</script> \n\
</body> \n\
</html>\n";
